<template>
    <client-only>
        <OwlCarousel
            :stage-padding="stagePadding"
            :margin="30"
            :items="items"
            :dots="false"
            :nav="true"
            data-aos="fade-up"
            data-aos-anchor=".-section"
            data-aos-once="true"
            class="brand-index-carousel"
        >
            <div
                v-for="(brand, b) in brands"
                :key="'brand-' + b"
                class="brand-container"
            >
                <p class="brand-title">{{ brand.alphabet }}</p>
                <ul>
                    <li
                        v-for="(brandItem, bi) in brand.record"
                        :key="'brand-item-' + bi"
                        class="brand-name-text pointer"
                        @click="goToFilter(brandItem.id, brandItem.name)"
                    >
                        {{ brandItem.name }}
                    </li>
                </ul>
            </div>
        </OwlCarousel>
    </client-only>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component({
    computed: mapGetters({
        menus: 'menu/getMenu',
    }),
})
export default class BrandIndexCarousel extends Vue {
    @Prop() readonly brands!: []

    // Data
    menus!: any
    items: Number = 5
    stagePadding: Number = 50

    // Methods
    goToFilter(id: number, name: string) {
        this.$store.commit('filter/setFilterBrandMutation', [id + '#' + name])
        this.$router.push(
            this.menus.BROWSESTREETWEAR.path + '?brands=' + encodeURI(name)
        )
    }

    mounted() {
        if (process.browser) {
            if (window.innerWidth <= 460) {
                this.items = 3
                this.stagePadding = 10
            }
        }
    }
}
</script>
